function [tarray zarray] = Euler(rhsname,tspan,z0,p)
%Euler method of solving any number of 1st order ODEs
znew = z0;              % get things started
ntimes = length(tspan); % Figure out how many times to evaluate
n_odes=length(z0);      % Figure out how many 1st order ODEs

zarray = zeros(ntimes,n_odes);   % initialize z
zarray(1,:) = znew'; 

%The main loop
for i = 2:ntimes
 t    = tspan(i-1);  % the present 'old' time  
 z    = znew;         % the new old is the old new
 h    = tspan(i) - tspan(i-1);   % size of full time step
 
 %Euler method is just the next 2 lines
 zdot  =  feval(rhsname,t,z,p);  % feval means function evaluation
 znew  =  z   + zdot*h;    % Half step ...
  
 zarray(i,:) = znew';  % store the new values as row of array
end
 
tarray=tspan;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


