function  zdot=rhs1(t,z,p)
% z comes in, zdot goes out.  Knowing the present state this 
% function calculates the rate of change of state. In this
% case, it uses Newton's universal law of gravitaiton and
% F=  ma.

% Try to make each line of code readable.
rA=z(1:2);  rB= z(3:4);  % Unpack z into variables with good names
vA=z(5:6);  vB= z(7:8);   

rAdot = vA;  rBdot=vB;  %The first 4 ODEs.

rAB = rB-rA;      % Position of B relative to A
r   = norm(rAB);  % Distance between A and B sqrt(dot(rAB,rAB))

%Newtons laws are the next 4 lines of code
FAB = (p.G * p.mA * p.mB / r^2) * (rAB/r);  %Gravity law
FBA = -FAB;  %Action and reaction (or, gravity law)

vAdot = FAB/p.mA;   % F = ma  (2 more odes)
vBdot = FBA/p.mB;   %        (and 2 more still)

zdot = [rAdot;rBdot; vAdot; vBdot];  % put together rdot and vdot
end
