function  zdot=rhs2(t,z,p)
% Two particles connected by a spring and dashpot
% The setup is the same as for two particles and gravity
% The only difference is the calculation of FAB and FBA
rA=z(1:2);  rB= z(3:4);
vA=z(5:6);  vB= z(7:8);   % Unpack z into variables with good names

rAdot = vA;  rBdot=vB;

rAB = rB-rA;
r   = norm(rB-rA);  % = dot(rB-rA,rB-rA)

%      spring force   dashpot force ......   unit vec
FAB = (p.k*(r-p.L0) + p.c*dot(vB-vA,rAB/r)) * (rAB/r);
FBA = -FAB;  %Acion and reaction

vAdot = FAB/p.mA;  % F = ma
vBdot = FBA/p.mA;  % F = ma


zdot = [rAdot;rBdot; vAdot; vBdot];  % put together rdot and vdot
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
